/*
 * Blackfin FIRtB^R[h Visual DSP++p
 *
 * Copyright(C) 2012 Kaneko System Co., Ltd.
 *
 * Last Update: 2012/08/22
 *
 * yӁz
 * EǂȂłRɉςĎgp邱Ƃł܂B
 * Ẽ\tgEFA͖ۏ؂łB̃t@CɋLڂĂER[h
 *   gpꍇ́A[U̐ӔCɂčsĂB̎gp
 *   NA[U܂͑O҂ɐQɊւAЂ͈؂̐ӔC
 *   ܂B
 *
 */

#include <blackfin.h>
#include <builtins.h>
#include <filter.h>
#include <math.h>
#include <stdint.h>
#include <string.h>

/* TvO_ */
#define NUM_SAMPLES		(1024)

#define NUM_TAPS		(sizeof(sf_fir_coeff) / sizeof(fract32))

/* fract32́Ashorttypedef. ƌŒ菬_̌^Ƌʂ邽߂
 * wb_t@CŒ`Ă.
 */
 
/* fir_fr32֐p̏ԕۑp[Nobt@ */
static fir_state_fr32 sf_fir_state;

/* ̓f[^pobt@(ADC̃f[^) */
static fract32 sf_input[NUM_SAMPLES];

/* FIRo͌ʗpobt@ */
static fract32 sf_output[NUM_SAMPLES];

/* FIRtB^̌W(Scilab̃c[ŌWZoĂ) */
/* TvOg : 16kHz */
/* JbgItg   : 1kHz LPF */
static fract32 sf_fir_coeff[] =
{
	78777,
	273306,
	656905,
	1247289,
	1968178,
	2609634,
	2834003,
	2250420,
	560609,
	-2254967,
	-5776242,
	-9092612,
	-10934662,
	-10012266,
	-5504485,
	2436867,
	12363295,
	21574109,
	26637364,
	24350512,
	12932053,
	-6901772,
	-31368985,
	-53873769,
	-66184425,
	-60363253,
	-31003341,
	22839336,
	96624820,
	180627617,
	261617397,
	325588657,
	360880585,
	360880585,
	325588657,
	261617397,
	180627617,
	96624820,
	22839336,
	-31003341,
	-60363253,
	-66184425,
	-53873769,
	-31368985,
	-6901772,
	12932053,
	24350512,
	26637364,
	21574109,
	12363295,
	2436867,
	-5504485,
	-10012266,
	-10934662,
	-9092612,
	-5776242,
	-2254967,
	560609,
	2250420,
	2834003,
	2609634,
	1968178,
	1247289,
	656905,
	273306,
	78777,
	};

/* fir_fr32֐p̒x */
static fract32 sf_fir_delay[NUM_TAPS];

static fract32 s_sin2pi_fr32(fract32 x)
{ 
	if(x < 0x20000000)
	{   /* <0.25  */
		/* first quadrant [0../2):                     */
		/* sin_fr32([0x0..0x7fffffff]) = [0..0x7fffffff) */
		return sin_fr32(x * 4);
	}
	else if(x == 0x20000000)
	{
		/* = 0.25 */
		return 0x7fffffff;
	}
	else if (x < 0x60000000)
	{
		/* < 0.75  */
		/* if (x < 0x40000000)                         */
		/* second quadrant [/2..):                 */
		/* -sin_fr32([0x8000..0x0)) = [0x7fff..0)      */
		/*                                             */
		/* if (x < 0x60000000)                         */
		/* third quadrant [..3/2):                 */
		/* -sin_fr32([0x0..0x7fff]) = [0..0x80000000)  */
		return -sin_fr32((0xc0000000 + x) * 4);
	}
	else
	{
		/* fourth quadrant [3/2..):                */
		/* sin_fr32([0x80000000..0x0)) = [0x80000000..0) */
		return sin_fr32((0x80000000 + x) * 4);
	}
}

void main(void)
{
	int32_t l_lc;
	
	/* sf_fir_statȅ(fir_init̓}N֐) */
	fir_init(sf_fir_state, sf_fir_coeff, sf_fir_delay, NUM_TAPS, 0);
	
	/* x[NA */
	memset(sf_fir_delay, 0, sizeof(sf_fir_delay));
	
	/* Kɓ̓f[^쐬
	 * ƂāATvO[g16kHzA1kHz3kHz̐g`
	 */
	for(l_lc = 0; l_lc < NUM_SAMPLES; l_lc++)
	{
		sf_input[l_lc] = (s_sin2pi_fr32((l_lc * 134217728) & 0x7FFFFFFF) / 2) + (s_sin2pi_fr32((l_lc * 402653184) & 0x7FFFFFFF) / 2);
	}
	
	/* FIRtB^ */
	/* W1kHzLFPȂ̂ŁAsf_outputɂ1kHz̐gcA3kHz̐g`܂. */
	fir_fr32(sf_input, sf_output, NUM_SAMPLES, &sf_fir_state);
}
